import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import dayjs from 'dayjs';
import sinon, { type SinonStubbedInstance } from 'sinon';

import StrutturaService from '@/entities/struttura/struttura.service';
import AlertService from '@/shared/alert/alert.service';
import { DATE_TIME_LONG_FORMAT } from '@/shared/composables/date-format';

import DisponibilitaUpdate from './disponibilita-update.vue';
import DisponibilitaService from './disponibilita.service';

type DisponibilitaUpdateComponentType = InstanceType<typeof DisponibilitaUpdate>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const disponibilitaSample = { id: 123 };

describe('Component Tests', () => {
  let mountOptions: MountingOptions<DisponibilitaUpdateComponentType>['global'];
  let alertService: AlertService;

  describe('Disponibilita Management Update Component', () => {
    let comp: DisponibilitaUpdateComponentType;
    let disponibilitaServiceStub: SinonStubbedInstance<DisponibilitaService>;

    beforeEach(() => {
      route = {};
      disponibilitaServiceStub = sinon.createStubInstance<DisponibilitaService>(DisponibilitaService);
      disponibilitaServiceStub.retrieve.onFirstCall().resolves(Promise.resolve([]));

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'b-input-group': true,
          'b-input-group-prepend': true,
          'b-form-datepicker': true,
          'b-form-input': true,
        },
        provide: {
          alertService,
          disponibilitaService: () => disponibilitaServiceStub,
          strutturaService: () =>
            sinon.createStubInstance<StrutturaService>(StrutturaService, {
              retrieve: sinon.stub().resolves({}),
            } as any),
        },
      };
    });

    afterEach(() => {
      vitest.resetAllMocks();
    });

    describe('load', () => {
      beforeEach(() => {
        const wrapper = shallowMount(DisponibilitaUpdate, { global: mountOptions });
        comp = wrapper.vm;
      });
      it('Should convert date from string', () => {
        // GIVEN
        const date = new Date('2019-10-15T11:42:02Z');

        // WHEN
        const convertedDate = comp.convertDateTimeFromServer(date);

        // THEN
        expect(convertedDate).toEqual(dayjs(date).format(DATE_TIME_LONG_FORMAT));
      });

      it('Should not convert date if date is not present', () => {
        expect(comp.convertDateTimeFromServer(null)).toBeNull();
      });
    });

    describe('save', () => {
      it('Should call update service on save for existing entity', async () => {
        // GIVEN
        const wrapper = shallowMount(DisponibilitaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.disponibilita = disponibilitaSample;
        disponibilitaServiceStub.update.resolves(disponibilitaSample);

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(disponibilitaServiceStub.update.calledWith(disponibilitaSample)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });

      it('Should call create service on save for new entity', async () => {
        // GIVEN
        const entity = {};
        disponibilitaServiceStub.create.resolves(entity);
        const wrapper = shallowMount(DisponibilitaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.disponibilita = entity;

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(disponibilitaServiceStub.create.calledWith(entity)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });
    });

    describe('Before route enter', () => {
      it('Should retrieve data', async () => {
        // GIVEN
        disponibilitaServiceStub.find.resolves(disponibilitaSample);
        disponibilitaServiceStub.retrieve.resolves([disponibilitaSample]);

        // WHEN
        route = {
          params: {
            disponibilitaId: `${disponibilitaSample.id}`,
          },
        };
        const wrapper = shallowMount(DisponibilitaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        // THEN
        expect(comp.disponibilita).toMatchObject(disponibilitaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        disponibilitaServiceStub.find.resolves(disponibilitaSample);
        const wrapper = shallowMount(DisponibilitaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
